package edu.umd.cloud9.collection.wikipedia.kba;

import org.apache.hadoop.conf.Configuration;
import org.apache.hadoop.fs.FileSystem;
import org.apache.hadoop.fs.Path;

import edu.umd.cloud9.collection.wikipedia.WikipediaForwardIndex;
import edu.umd.cloud9.collection.wikipedia.WikipediaPage.Link;
import edu.umd.cloud9.collection.wikipedia.language.EnglishWikipediaPage;

public class LookupArticle {
  public static void main(String[] args) throws Exception {
    String findex = "/scratch0/collections/wikipedia/enwiki-20120104.findex.dat";
    String docno = "/scratch0/collections/wikipedia/enwiki-20120104-docno.dat"; 

    Configuration conf = new Configuration();
    WikipediaForwardIndex f = new WikipediaForwardIndex(conf);
    f.loadIndex(new Path(findex), new Path(docno), FileSystem.get(conf));

    EnglishWikipediaPage page = (EnglishWikipediaPage) f.getDocument("23436561");
    System.out.println(page.getRawXML());
    for (Link l : page.extractLinks()) {
      System.out.println(l);
    }
  }
}
