package edu.umd.cloud9.collection.wikipedia.kba;

import java.io.BufferedReader;
import java.io.FileReader;

import org.apache.hadoop.conf.Configuration;
import org.apache.hadoop.fs.FileSystem;
import org.apache.hadoop.fs.Path;

import edu.umd.cloud9.collection.wikipedia.WikipediaForwardIndex;
import edu.umd.cloud9.collection.wikipedia.WikipediaPage;
import edu.umd.cloud9.collection.wikipedia.WikipediaPage.Link;
import edu.umd.cloud9.collection.wikipedia.language.EnglishWikipediaPage;
import edu.umd.cloud9.util.map.HMapKF;
import edu.umd.cloud9.util.map.MapKF;

public class ScoreLinks {
  public static void main(String[] args) throws Exception {
    String findex = "/scratch0/collections/wikipedia/enwiki-20120104.findex.dat";
    String docno = "/scratch0/collections/wikipedia/enwiki-20120104-docno.dat"; 

    Configuration conf = new Configuration();
    WikipediaForwardIndex f = new WikipediaForwardIndex(conf);
    f.loadIndex(new Path(findex), new Path(docno), FileSystem.get(conf));

    HMapKF<String> scores = new HMapKF<String>();
    BufferedReader br = new BufferedReader(new FileReader(args[0]));
    String line;
    while ((line = br.readLine()) != null) {
      String[] arr = line.split("\\t");

      EnglishWikipediaPage page = (EnglishWikipediaPage) f.getDocument(arr[2]);

      //System.out.println("###" + page.getTitle());

      for (WikipediaPage.Link link : page.extractLinks()) {
        //System.out.println(link.getAnchorText() + "\t" + link.getTarget());
        float score = (float) Math.exp(Double.parseDouble(arr[4]));
        if (arr[2].equals("2065870") || arr[2].equals("1033659") ) {
          score = (float) Math.exp(-5.574844) * 2;
        }
        scores.increment(link.getTarget(), score);
      }

    }
    br.close();

    for ( MapKF.Entry<String> entry : scores.getEntriesSortedByValue(100) ) {
      System.out.println(entry.getKey() + "\t" + entry.getValue());
    }
  }
}
